﻿/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
 var isOK = 0;
 
 var app = {
    // Application Constructor
    initialize: function() {
		printLog("app.initialize()");
        document.addEventListener('deviceready', this.onDeviceReady.bind(this), false);
    },

    // deviceready Event Handler
    //
    // Bind any cordova events here. Common events are:
    // 'pause', 'resume', etc.
    onDeviceReady: function() {
		printLog("isOK = 1;");
        isOK = 1;
        saveUDID();
    }

};
 
//Android//browser//iOS
function getDevicePlatform(){return (isOK==1)?device.platform:"platform";};
//2.2//2.0.1
function getDeviceVersion(){return (isOK==1)?device.version:"2.0.0";};
//motorola//huawei
function getDeviceManufacturer(){return (isOK==1)?device.manufacturer:"manufacturer";};
//if simulator is true
function getDeviceIsVirtual(){return (isOK==1)?device.isVirtual:0;};
//UUID
function getDeviceUUID(){
	var UDID = getCacheData('UDID');
	if(null!=UDID){
		return UDID;
	}
	return (isOK==1)?device.uuid:"uuid";
};
//model
function getDeviceModel(){return (isOK==1)?device.model:"model";};
//serial
function getDeivceSerial(){return (isOK==1)?device.serial:"serial";};
//WiFi//2G//3G//4G//NoNetwork
function getNetworkInfomation(){
    var states = {};
    states[Connection.UNKNOWN]  = 'Unknown';
    states[Connection.ETHERNET] = 'Ethernet';
    states[Connection.WIFI]     = 'WiFi';
    states[Connection.CELL_2G]  = '2G';
    states[Connection.CELL_3G]  = '3G';
    states[Connection.CELL_4G]  = '4G';
    states[Connection.CELL]     = 'CellGeneric';
    states[Connection.NONE]     = 'NoNetwork';
	if(isOK!=1){
		return states[Connection.UNKNOWN];
	}
	var networkState = navigator.connection.type;
	return states[networkState];
};
//open url
function openUrl(isInApp, url){
	if(isInApp){
		var ref = cordova.InAppBrowser.open(url, '_blank','location=no', 'zoom=no', 'hardwareback=yes');
		return ref;
	}else{
		var ref = cordova.InAppBrowser.open(url, '_system','location=no', 'zoom=no', 'hardwareback=yes');
		return ref;
	}
};

//
function sureVar(varname){
	if(null!=varname && undefined!=varname && ''!=varname && 'null'!=varname && 'undefined'!=varname){
		return varname;
	}
	return null;
};

//
function printLog(log) {
	//console.log(log);
};


function getCacheData(key){
	var storage = window.localStorage;
	var value = storage.getItem(key);
	printLog("getCacheData(" + key + ")=" + value);
	return sureVar(value);
}
//
function saveCacheData(key,value){
	var storage = window.localStorage;
	printLog("saveCacheData()" + key + "=" + value);
	storage.setItem(key, value);
}

function jsonToHttpRequestParams(aJsonString){
	aJsonString=aJsonString.replace(/,/g,'&');
	aJsonString=aJsonString.replace(/"/g,'');
	aJsonString=aJsonString.replace(/:/g,'=');
	return aJsonString;
}
function getJsonLength(jsonData){
	var jsonLength = 0;
	for(var item in jsonData){
		jsonLength++;
	}
	return jsonLength;
}

function GetQueryString(name)
{
     var reg = new RegExp("(^|&)"+ name +"=([^&]*)(&|$)");
     var r = window.location.search.substr(1).match(reg);
     if(r!=null)return  unescape(r[2]); return null;
}

function saveUDID(){
    JwCordovaPlugin.getPropertiesData("DEVICEENGINE.dat","udid",function(result){
        printLog('JwCordovaPlugin.getPropertiesData(udid)'+result);
        saveCacheData('UDID',result);
    },function(error){
        printLog('JwCordovaPlugin.getPropertiesData(error)'+error);
    });
}





//
function checkInstalledQQ(){
	var QQINSTALLED = false;
	try{
		YCQQ.checkClientInstalled(function(){
			QQINSTALLED=true;
		},function(){
			// if installed QQ Client version is not supported sso,also will get this error
			QQINSTALLED=false;
		});
	}catch(error){}
	return QQINSTALLED;
};
//
function checkInstalledWX(){
	var WEIXININSTALL = false;
	try{
		Wechat.isInstalled(function (installed) {
			WEIXININSTALL=installed;
		});
	}catch(error){}
	return WEIXININSTALL;
};
//
function checkInstalledWB(){
	var WEIBOINSTALL = false;
	try{
		YCWeibo.checkClientInstalled(function(){
			WEIBOINSTALL=true;
		},function(){
			WEIBOINSTALL=false;
		});
	}catch(error){}
	return WEIBOINSTALL;
};
function QQLogin(){
	var checkClientIsInstalled = 1;//default is 0,only for iOS
	YCQQ.ssoLogin(function(args){
			alert(args.access_token);
			alert(args.userid);
		},function(failReason){
			console.log(failReason);
		},checkClientIsInstalled);
};
function WXLogin(){
	var scope = "snsapi_userinfo";
	Wechat.auth(scope, function (response) {
			// you may use response.code to get the access token.
			alert(JSON.stringify(response));
		}, function (reason) {
			alert("Failed: " + reason);
		});
};
function WBLogin(){
	YCWeibo.ssoLogin(function(args){
			alert(args.access_token);
			alert(args.userid);
		},function(failReason){
			console.log(failReason);
		});
};


app.initialize();